<?php
// $HeadURL: http://joomlacode.org/svn/joomgallery/JG-1.5/JG/trunk/administrator/components/com_joomgallery/admin.joomgallery.php $
// $Id: admin.joomgallery.php 391 2009-02-22 11:53:16Z aha $
/******************************************************************************\
**   JoomGallery  1.5 RC2                                                     **
**   By: JoomGallery::ProjectTeam                                             **
**   Copyright (C) 2008 - 2009  M. Andreas Boettcher                          **
**   Based on: JoomGallery 1.0.0 by JoomGallery::ProjectTeam                  **
**   Released under GNU GPL Public License                                    **
**   License: http://www.gnu.org/copyleft/gpl.html or have a look             **
**   at administrator/components/com_joomgallery/LICENSE.TXT                  **
\******************************************************************************/

defined('_JEXEC') or die('Direct Access to this location is not allowed.');

/** portierung **/
$database = & JFactory::getDBO();
$mainframe = & JFactory::getApplication('administrator');
define('_JOOM_LIVE_SITE',$mainframe->getSiteUrl());

require_once($mainframe->getPath('class'));
require_once($mainframe->getPath('admin_html'));
require_once(JPATH_COMPONENT.DS.'common.joomgallery.php');

//configuration
$config = Joom_getConfig();

//sanitize other variables
$id                    = Joom_mosGetParam('id', null);
$act                   = Joom_mosGetParam('act', null);
$task                  = Joom_mosGetParam('task', null);
$cid                   = Joom_mosGetParam('cid', '');
$catid                 = JRequest::getInt('catid', '');

define('_JOOM_OPTION',JRequest::getCmd('option','com_joomgallery'));

switch($act) {
  case 'categories':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.categories.php');
    $task = 'categories';
    break;

  case 'pictures':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.pictures.php');
    $task = 'pictures';
    break;

  case 'comments':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.comments.php');
    $task = 'comments';
    break;

  case 'votes':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.votes.php');
    $task = 'votes';
    break;

  case 'upload':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.uploads.php');
    $task = 'upload';
    break;

  case 'batchupload':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.uploads.php');
    $task = 'batchupload';
    break;

  case 'ftpupload':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.uploads.php');
    $task = 'ftpupload';
    break;

  case 'jupload':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.uploads.php');
    $task = 'jupload';
    break;

  case 'configuration':
    //check update xml from previous update and delete them
    if(file_exists(JPATH_COMPONENT.DS.'joomgalleryupdate.xml')) {
      @unlink(JPATH_COMPONENT.DS.'joomgalleryupdate.xml');
    }
    $task = 'configuration';
    break;

  case 'editcss':
    //TODO require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.cssedit.php');
    $task = 'editcss';
    break;

  case 'migrate':
    $task = 'migrate';
    break;

  case 'help':
    $task = 'help';
    break;
  }

  switch($task) {
		//Categories
    case 'categories':
    case 'orderupcatg':
    case 'orderdowncatg':
    case 'publishcatg':
    case 'unpublishcatg':
    case 'approvecat':
    case 'rejectcat':
    case 'newcatg':
    case 'savenewcatg':
    case 'editcatg':
    case 'saveeditcatg':
    case 'removecatg':
    case 'cancelcatg':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.categories.php');
      $categoryclass = new Joom_AdminCategories($task, $cid);
      break;

		//Pictures
    case 'pictures':
    case 'newpic':
    case 'savenewpic':
    case 'editpic':
    case 'saveeditpic':
    case 'canceleditpic':
    case 'movepic':
    case 'savemovepic':
    case 'publishpic':
    case 'unpublishpic':
    case 'approvepic':
    case 'rejectpic':
    case 'orderup':
    case 'orderdown':
    case 'removepic':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.pictures.php');
      $pictureclass = new Joom_AdminPictures($task, $cid, $id);
      break;

		//Categories & Pictures
    case 'saveorder':
      Joom_SaveOrder($id, $cid);
      break;

		//Comments
    case 'comments':
    case 'publishcmt':
    case 'unpublishcmt':
    case 'approvecmt':
    case 'rejectcmt':
    case 'removecmt':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.comments.php');
      $commentsclass = new Joom_AdminComments($task, $id);
      break;

		// Votes
    case 'votes':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.votes.php');
      $voteclass = new Joom_AdminVotes($task);
      break;

		//Uploads
    case 'upload':
    case 'batchupload':
    case 'ftpupload':
    case 'jupload':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.uploads.php');
      $adminuploadclass = new Joom_AdminUploads($task);
      break;

		//Upload functions
    case 'uploadhandler':
    case 'batchuploadhandler':
    case 'ftpuploadhandler':
    case 'juploadhandler_receive':
      require_once(JPATH_COMPONENT.DS.'adminclasses'.DS.'admin.upload.class.php');
      $uploadclass = new Joom_Upload($task, $catid);
      break;

		//Configuration
    case 'configuration':
      require_once(JPATH_COMPONENT.DS.'adminclasses'.DS.'admin.tabs.class.php');
    case 'saveconfiguration':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.configuration.php');
      $configurationclass = new Joom_AdminConfiguration($task);
      break;

		// CSS-modification
    case 'savecss':
    case 'cancelcss':
    case 'deletecss':
    case 'editcss':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.cssedit.php');
      $cssclass = new Joom_AdminCssEdit($task);
      break;

		//Migration
    case 'migrate':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.migration.php');
      $adminmigrateclass = new Joom_AdminMigration($task);
      break;

		//Help
    case 'help':
      require_once(JPATH_COMPONENT.DS.'includes'.DS.'admin.help.php');
      $adminhelpclass = new Joom_AdminHelp($task);
      break;

		//Default
    default:
      Joom_ShowMenu_HTML();
      break;
  }

$tasks = array('categories','pictures','comments','votes','upload','batchupload',
               'ftpupload','jupload','configuration','editcss','migrate','help');
if($config->jg_checkupdate && in_array($task, $tasks)){
  $dated_extensions = Joom_CheckUpdate();
  if(count($dated_extensions)){
    JError::raiseNotice('302', JText::_('JGA_SYSTEM_NOT_UPTODATE'));
  }
}
Joom_ShowFooter_HTML();
?>