<?php
// $HeadURL: http://joomlacode.org/svn/joomgallery/JG-1.5/JG/trunk/administrator/components/com_joomgallery/adminclasses/admin.upload.class.php $
// $Id: admin.upload.class.php 391 2009-02-22 11:53:16Z aha $
/******************************************************************************\
**   JoomGallery  1.5 RC2                                                     **
**   By: JoomGallery::ProjectTeam                                             **
**   Copyright (C) 2008 - 2009  M. Andreas Boettcher                          **
**   Based on: JoomGallery 1.0.0 by JoomGallery::ProjectTeam                  **
**   Released under GNU GPL Public License                                    **
**   License: http://www.gnu.org/copyleft/gpl.html or have a look             **
**   at administrator/components/com_joomgallery/LICENSE.TXT                  **
\******************************************************************************/

defined('_JEXEC' ) or die( 'Direct Access to this location is not allowed.');

/**
* Upload functions for backend
* - Batch (Zip)
* - FTP
* - Single upload
* - JAVA Applet (jupload)
*/
class Joom_Upload {
  // TODO,aha: how to implement debug output in future?
  var $debug;
  var $gentitle;
  var $gendesc;
  var $photocred;
  var $filecounter;
  var $file_delete;
  var $original_delete;
  var $create_special_gif;
  var $arrscreenshot;
  var $zippack;
  var $ftpfiles;
  var $subdirectory;
  var $imgname_separator;

/**
 * Constructor
 *
 * @param string $task type of upload
 * @param int $catid destination category
 * @return Joom_Upload
 */
function Joom_Upload($task, $catid) {
  $database = & JFactory::getDBO();
  $user = & JFactory::getUser();
  jimport('joomla.filesystem.file');

  $this->debug               = JRequest::getInt('debug', 0);
  $this->subdirectory        = Joom_mosGetParam('subdirectory', DS, 'post');
  $this->gentitle            = Joom_mosGetParam('gentitle', '', 'post');
  $this->gendesc             = Joom_FixUserEntrie(Joom_mosGetParam('gendesc', ''));
  $this->photocred           = Joom_FixUserEntrie(Joom_mosGetParam('photocred', ''));

  $this->filecounter         = Joom_mosGetParam('filecounter', '', 'post');
  $this->file_delete         = Joom_mosGetParam('file_delete', '', 'post');
  $this->original_delete     = Joom_mosGetParam('original_delete', '', 'post');
  $this->create_special_gif  = Joom_mosGetParam('create_special_gif', '', 'post');
  $this->arrscreenshot       = Joom_mosGetParam('arrscreenshot', '', 'files');
  $this->zippack             = Joom_mosGetParam('zippack', '', 'files');
  $this->ftpfiles            = Joom_mosGetParam('ftpfiles', '', 'post');

  //TODO aha: configurable?
  $this->imgname_separator   = '_';

  switch($task) {
    //Single upload
    case 'uploadhandler':
      $this->Upload_Singles_Backend($catid);
      break;
    //ZIP upload
    case 'batchuploadhandler':
      $this->Upload_Batch($catid);
      break;
    //FTP upload
    case 'ftpuploadhandler':
      $this->Upload_FTP($catid);
      break;
    //JAVA upload
    case 'juploadhandler_receive':
      $this->Upload_AppletReceive_Backend($catid);
      break;
    default:
      die('Wrong Task');
      break;
  }
}

/**
 * Extract pictures from zip
 *
 * @param int $catid id of destination category
 */
function Upload_Batch($catid) {
  $config = Joom_getConfig();
  $mainframe = & JFactory::getApplication('administrator');
  $database = & JFactory::getDBO();
  $user = & JFactory::getUser();

  if (is_dir(JPATH::clean(JPATH_ROOT.DS.$config->jg_pathtemp))) {
    $temp_dir = $config->jg_pathtemp;
  } else {
    echo "<script> alert('".JText::_('JGA_ERROR_TEMP_MISSING',true)."'); </script>\n";
    exit();
  }

  //include zip class
  if (file_exists(JPATH_ADMINISTRATOR.DS.'classes'.DS.'pclzip.lib.php')) {
    require_once(JPATH_ADMINISTRATOR.DS.'classes'.DS.'pclzip.lib.php');
  } else {
    require_once(JPATH_ADMINISTRATOR.DS.'includes'.DS.'pcl'.DS.'pclzip.lib.php');
  }

  //check existence of uploaded zip
  if (!file_exists($this->zippack["tmp_name"])) {
      echo "<script> alert('".JText::_('JGA_ERROR_FILE_NOT_UPLOADED',true)."'); window.history.go(-1); </script>\n";
      exit();
  }

  //Create ZIP object, make array containing file info, and extract files to temporary location
  $this->zippack = $this->zippack["tmp_name"];
  $zipfile = new PclZip($this->zippack);
  $ziplist = $zipfile->listContent();
  $zipfile->extract(PCLZIP_OPT_PATH,JPath::clean(JPATH_ROOT.DS.$temp_dir),PCLZIP_OPT_REMOVE_ALL_PATH);

  //check error code of extraction
  if ($zipfile->error_code != 1) {
    $ziperror = str_replace("'","",$zipfile->errorInfo());
    echo "<script> alert('".$ziperror."'); window.history.go(-1); </script>\n";
    exit();
  }
  echo '<p />';

  $sizeofzip = sizeof($ziplist);
  
  //For each file extracted from zip get original filename and create unique filename
  //copy to new location, delete file in temp. location, make thumbnail and add to database
  echo '---------------------------------<br />' . "\n";
  echo $sizeofzip . ' ' . JText::_('JGA_FILES_IN_BATCH') . '<br />' . "\n";
  echo '---------------------------------<br />' . "\n";
  usort($ziplist, "Joom_SortBatch");
  $ziplist = array_reverse($ziplist);

  //Path of category
  $catpath = Joom_GetCatPath($catid);

  for ($i=0; $i < $sizeofzip; $i++) {
    $origfilename = $ziplist[$i]['filename'];
    $fileextension = strtolower(JFile::getExt($origfilename));
    
    //get the serial number if use of original name is deactivated
    //and numbering is activated
    if (!$config->jg_useorigfilename && $config->jg_filenamenumber){
      $picserial=$this->Upload_GetSerial($sizeofzip);
    }

    //Check for path exploits, and replace spaces
    if ( $config->jg_useorigfilename ) {
      $compacttitle = Joom_FixFilename($origfilename,1);
    } else {
      $compacttitle = Joom_FixFilename($this->gentitle);
    }
    if( $config->jg_filenamenumber > 0 ) {
      $newfilename = $this->Upload_GenFilename($compacttitle,$fileextension,$picserial);
    } else {
      $newfilename = $this->Upload_GenFilename($compacttitle,$fileextension);
    }

    echo '<hr /><br />' . "\n";
    echo JText::_('JGA_FILENAME') . '&#35;';
    echo "$origfilename <br />\n";
    echo JText::_('JGA_NEW_FILENAME') . ": $newfilename <br />";

    //Move the picture from temp. folder to originals folder
    if (JFile::move($temp_dir.DS.$origfilename,
                    $config->jg_pathoriginalimages.$catpath.$newfilename,
                    JPATH_ROOT)) {

      //Set permissions to 644
      JPath::setPermissions(JPath::clean(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename));
      echo JText::_('JGA_UPLOAD_START') . '<br />';
    } else {
      die(JText::_('JGA_PROBLEM_COPYING') . ': ' . JPath::clean(JPATH_ROOT.DS.$config->jg_pathoriginalimages) . '. ' . JText::_('JGA_CHECK_PERMISSIONS'));
    }
    echo JText::_('JGA_UPLOAD_COMPLETE') . '<br />';

    //Create the thumb from original picture
    Joom_ResizeImage(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename,
                     JPATH_ROOT.DS.$config->jg_paththumbs.$catpath.$newfilename,
                     $config->jg_useforresizedirection, $config->jg_thumbwidth, $config->jg_thumbheight,
                     $config->jg_thumbcreation, $config->jg_thumbquality);
    echo JText::_('JGA_THUMBNAIL_CREATED') . '<br />';

    //Create the detail picture from original
    if ($config->jg_resizetomaxwidth) {
      Joom_ResizeImage(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename,
                       JPATH_ROOT.DS.$config->jg_pathimages.$catpath.$newfilename,
                       false, $config->jg_maxwidth, false,$config->jg_thumbcreation,
                       $config->jg_thumbquality, true);
      echo JText::_('JGA_RESIZED_TO_MAXWIDTH') . '...<br />';
    }
    if($config->jg_delete_original == 1 || ($config->jg_delete_original== 2 && $this->original_delete==1)) {
      //Delete original if setted in backend
      if(JFile::delete(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename)) {
        echo JText::_('JGA_ORIGINAL_DELETED') . '<br />';
      }
      else {
        die(JText::_('JGA_PROBLEM_DELETING_ORIGINAL') . ': ' . JPath::clean(JPATH_ROOT.DS.$config->jg_pathoriginalimages) . ' ' . JText::_('JGA_CHECK_PERMISSIONS'));
     }
    }
    //New entry for ordering
    $ordering = $this->Upload_GetOrdering($config->jg_uploadorder,$catid);

    if ($config->jg_useorigfilename) {
      $fileextensionlength = strlen($fileextension);
      $filenamelength = strlen($origfilename);
      $imgname = substr($origfilename,-$filenamelength,-$fileextensionlength-1);
    } else {
      if ($config->jg_filenamenumber == 1) {
        $imgname = $this->gentitle.$this->imgname_separator.$picserial;
      } else {
        $imgname = $this->gentitle;
      }
    }

    $batchtime = mktime();
    $database->setQuery( "INSERT INTO #__joomgallery(id, catid, imgtitle, imgauthor,
        imgtext, imgdate, imgcounter, imgvotes,
        imgvotesum, published, imgfilename, imgthumbname,
        checked_out,owner,approved, ordering)
        VALUES
        (NULL, '$catid', '$imgname', '$this->photocred',
        '$this->gendesc', '$batchtime', '0', '0',
        '0', '1', '$newfilename', '$newfilename',
        '0', '".$user->get('id')."', 1, '$ordering')");

    if (!$database->query()) {
      echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
      exit();
    }
  }
  echo '<hr /><br />' . "\n";
  if(!$this->debug) {
    $mainframe->redirect('index.php?option='._JOOM_OPTION.'&act=batchupload',JText::_('JGA_UPLOAD_SUCCESSFULL'));
  }

}

/**
* FTP Upload
* several picture uploaded via FTP before are moved to an category
* HTML function: Joom_ShowFTPUpload()
* @param string id of destination category
*/
function Upload_FTP ($catid) {
  $config = Joom_getConfig();
  $mainframe = & JFactory::getApplication('administrator');
  $database = & JFactory::getDBO();
  $user = & JFactory::getUser();

  $sizeftpfiles = sizeof($this->ftpfiles);

  //Path of category
  $catpath = Joom_GetCatPath($catid);

  foreach ($this->ftpfiles as $screenshot_name) {
    //get the serial number if use of original name is deactivated
    //and numbering is activated
    if (!$config->jg_useorigfilename && $config->jg_filenamenumber){
      $picserial=$this->Upload_GetSerial($sizeftpfiles);
    }
    
    $fileextension = strtolower(JFile::getExt($screenshot_name));

    if ( $config->jg_useorigfilename ) {
      $compacttitle = Joom_FixFilename($screenshot_name, 1);
    } else {
      $compacttitle = Joom_FixFilename($this->gentitle);
    }

    if(!$config->jg_useorigfilename && $config->jg_filenamenumber) {
      $newfilename = $this->Upload_GenFilename($compacttitle,$fileextension,$picserial);
    } else {
      $newfilename = $this->Upload_GenFilename($compacttitle,$fileextension);
    }

    echo '<p />';
    echo "$screenshot_name<br />";

    //Create thumbnail
    Joom_ResizeImage(JPATH_ROOT.DS.$config->jg_pathftpupload.$this->subdirectory.$screenshot_name,
                     JPATH_ROOT.DS.$config->jg_paththumbs.$catpath.$newfilename,
                     $config->jg_useforresizedirection,$config->jg_thumbwidth, $config->jg_thumbheight,
                     $config->jg_thumbcreation, $config->jg_thumbquality);

    echo JText::_('JGA_THUMBNAIL_CREATED') . '<br />';

    //Create detail picture only if jpg and maxwidth setted
    if ($config->jg_resizetomaxwidth  && ($this->create_special_gif!=1 ||
       ($fileextension!='gif' && $fileextension!='png'))) {
      Joom_ResizeImage(JPATH_ROOT.DS.$config->jg_pathftpupload.$this->subdirectory.$screenshot_name,
                       JPATH_ROOT.DS.$config->jg_pathimages.$catpath.$newfilename,
                       false, $config->jg_maxwidth,false, $config->jg_thumbcreation,
                       $config->jg_thumbquality, true);

      echo JText::_('JGA_RESIZED_TO_MAXWIDTH') . '...<br />';
    } else {
      //Otherwise only copy the picture
      JFile::copy($config->jg_pathftpupload.$this->subdirectory.$screenshot_name,
                  $config->jg_pathimages.$catpath.$newfilename,
                  JPATH_ROOT);
      JPath::setPermissions(JPath::clean(JPATH_ROOT.DS.$config->jg_pathimages.$catpath.$newfilename));
    }

    //Copy or move picture in originals?
    if(!($config->jg_delete_original == 1 || ($config->jg_delete_original== 2 && $this->original_delete==1))) {
      //Create original picture file in original
      //if file has to be deleted from upload directory move them to originals
      if ($this->file_delete == 1) {
        if (!JFile::move($config->jg_pathftpupload.$this->subdirectory.$screenshot_name,
                         $config->jg_pathoriginalimages.$catpath.$newfilename,
                         JPATH_ROOT)) {
          echo JText::_('JGA_COULD_NOT_DELETE_PICTURE') . '<br />';
          $this->debug = 1;
          continue;
        } else {
          JPath::setPermissions(JPath::clean(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename));
        }
      } else {
        //Otherwise copy them into originals
        if (JFile::copy($config->jg_pathftpupload.$this->subdirectory.$screenshot_name,
                        $config->jg_pathoriginalimages.$catpath.$newfilename,
                        JPATH_ROOT)) {
          JPath::setPermissions(JPath::clean(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename));
        } else {
          $this->debug = 1;
          echo JText::_('JGA_WRONG_FILENAME');
          continue;
        }
      }
    } else {
      //Original picture shall not be created
      //evtl delete them from upload directory
      if ($this->file_delete == 1) {
        if (!JFile::delete(JPATH_ROOT.DS.$config->jg_pathftpupload.$this->subdirectory.$screenshot_name)) {
          echo JText::_('JGA_COULD_NOT_DELETE_PICTURE') . '<br />';
          $this->debug = 1;
          continue;
        }
      }
    }

    $ordering = $this->Upload_GetOrdering ($config->jg_uploadorder,$catid);

    if ($config->jg_useorigfilename) {
      $fileextensionlength = strlen($fileextension);
      $filenamelength = strlen($screenshot_name);
      $imgname = substr($screenshot_name,-$filenamelength,-$fileextensionlength-1);
    } else {
      if ($config->jg_filenamenumber == 1) {
        $imgname = $this->gentitle.$this->imgname_separator.$picserial;
      } else {
        $imgname = $this->gentitle;
      }
    }

    $batchtime = mktime();
    $database->setQuery( "INSERT INTO #__joomgallery(id, catid, imgtitle, imgauthor,
        imgtext, imgdate, imgcounter, imgvotes,
        imgvotesum, published, imgfilename, imgthumbname,
        checked_out,owner,approved, ordering)
        VALUES
        (NULL, '$catid', '$imgname', '$this->photocred',
        '$this->gendesc', '$batchtime', '0', '0',
        '0', '1', '$newfilename', '$newfilename',
        '0', '".$user->get('id')."', 1, '$ordering')");

    if (!$database->query()) {
      echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
      exit();
    }
  }
  if(!$this->debug) {
    $mainframe->redirect('index.php?option='._JOOM_OPTION.'&act=ftpupload&batchul=1',JText::_('JGA_UPLOAD_SUCCESSFULL'));
  }
}

/**
* Single upload
* up to 10 pictures are chosen and uploaded before
* @param string id from destination category
*/
function Upload_Singles_Backend ($catid) {
  $config = Joom_getConfig();
  $mainframe = & JFactory::getApplication('administrator');
  $database = & JFactory::getDBO();
  $user = & JFactory::getUser();

  //Path of category
  $catpath = Joom_GetCatPath($catid);

  for ($i=0; $i < 10; $i++) {
    echo '<hr />';
    $pos=$i+1;
    //TODO: Language
    echo 'verarbeite Bild an Position: '.$pos.'<br />';
    //Any picture entry at position?
    //if not continue
    if (empty($this->arrscreenshot["tmp_name"][$i])) {
      //TODO: Language
      echo 'Kein Eintrag an Position: '.$pos.'<br />';
      continue;
    }
    if ($this->arrscreenshot["error"][$i] > 0) {
      //TODO: Language
      echo 'Upload-Fehler bei Bild: '.$ipos.'<br />';
      $this->Upload_CheckError($this->arrscreenshot["error"][$i]);
      $this->debug = 1;
      continue;
    }

    $screenshot       =$this->arrscreenshot["tmp_name"][$i];
    $screenshot_name  =$this->arrscreenshot["name"][$i];
    $screenshot_name  = Joom_FixFilename($screenshot_name);
    echo '<p />';

    $tag = strtolower(JFile::getExt($screenshot_name));

    //Create new filename
    //if generic filename setted in backend use them
    if ( $config->jg_useorigfilename ) {
      $screenshot_name = Joom_FixFilename($screenshot_name);
      $newfilename = $this->Upload_GenFilename($screenshot_name,$tag);
    } else {
      $screenshot_name = Joom_FixFilename($this->gentitle);
      $newfilename = $this->Upload_GenFilename($screenshot_name,$tag);
    }

    //move uploaded picture to originals
    if ((($tag == 'jpeg') || ($tag == 'jpg') || ($tag == 'jpe') || ($tag == 'gif') || ($tag == 'png'))
        && strlen($screenshot) > 0 && $screenshot != 'none'
        && JFile::upload($screenshot,JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename)) {
      JPath::setPermissions(JPath::clean(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename));

      //create thumbnail
      Joom_ResizeImage(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename,
                       JPATH_ROOT.DS.$config->jg_paththumbs.$catpath.$newfilename,
                       $config->jg_useforresizedirection, $config->jg_thumbwidth, $config->jg_thumbheight,
                       $config->jg_thumbcreation, $config->jg_thumbquality);
      echo JText::_('JGA_THUMBNAIL_CREATED') . '<br />';

      //evtl create detail picture
      if ($config->jg_resizetomaxwidth && ($this->create_special_gif!=1 || ($tag!='gif' && $tag!='png'))) {
        Joom_ResizeImage(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename,
                         JPATH_ROOT.DS.$config->jg_pathimages.$catpath.$newfilename, false,
                         $config->jg_maxwidth, false, $config->jg_thumbcreation, $config->jg_thumbquality, true);
        echo JText::_('JGA_RESIZED_TO_MAXWIDTH') . '...<br />';
      } else {
        JFile::copy($config->jg_pathoriginalimages.$catpath.$newfilename,
                    $config->jg_pathimages.$catpath.$newfilename,
                    JPATH_ROOT);
        JPath::setPermissions(JPath::clean(JPATH_ROOT.DS.$config->jg_pathimages.$catpath.$newfilename));
      }

      if($config->jg_delete_original == 1 || ($config->jg_delete_original== 2 && $this->original_delete==1)) {
        //Remove picture from originals if chosen in backend
        if(JFile::delete(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename)) {
          echo JText::_('JGA_ORIGINAL_DELETED') . '<br />';
        } else {
          die(JText::_('JGA_PROBLEM_DELETING_ORIGINAL') . ': ' . JPath::clean(JPATH_ROOT.DS.$config->jg_pathoriginalimages) . ' ' . JText::_('JGA_CHECK_PERMISSIONS'));
        }
      }

      //New entry for ordering
      $ordering = $this->Upload_GetOrdering($config->jg_uploadorder,$catid);

      $batchtime = mktime();
      if ( $config->jg_useorigfilename ) {
        $fileextensionlength = strlen($tag);
        $filenamelength = strlen($screenshot_name);
        $imgname = substr($screenshot_name,-$filenamelength,-$fileextensionlength-1);
      } else {
        $imgname = $this->gentitle;
      }
      $query= "INSERT INTO #__joomgallery(id, catid, imgtitle, imgauthor,
          imgtext, imgdate, imgcounter, imgvotes,
          imgvotesum, published, imgfilename, imgthumbname,
          checked_out,owner,approved, ordering)
          VALUES
          (NULL, '$catid', '$imgname', '$this->photocred',
          '$this->gendesc', '$batchtime', '0', '0',
          '0', '1', '$newfilename', '$newfilename',
          '0', '".$user->get('id')."', 1, '$ordering')";

      $result = $database->setQuery($query);

      if (!$database->query()) {
          echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
        exit();
      }
    } else {
      echo JText::_('JGA_WRONG_FILENAME') ;
    }
  }
  if(!$this->debug) {
    $mainframe->redirect('index.php?option='._JOOM_OPTION.'&act=upload&batchul=1',JText::_('JGA_UPLOAD_SUCCESSFULL'));
  }
}


/**
* JAVA Applet upload
* @param Kategorie id of destination category
*/
function Upload_AppletReceive_Backend ($catid) {
  $config = Joom_getConfig();
  $database = & JFactory::getDBO();
  $user = & JFactory::getUser();

  //The Applet recognize an error with the text 'JOOMGALLERYUPLOADERROR'
  //and shows them within an JS alert box

  //check common requirements
  //no catid
  if ($catid == 0) {
    echo('JOOMGALLERYUPLOADERROR '.JText::_('JGA_JUPLOAD_YOU_MUST_SELECT_CATEGORY'));
    die;
  }
  //non common title
  if (!$config->jg_useorigfilename && empty($this->gentitle)) {
    echo('JOOMGALLERYUPLOADERROR '.JText::_('JGA_JUPLOAD_PICTURE_MUST_HAVE_TITLE'));
    die;
  }
  //Category path
  $catpath = Joom_GetCatPath($catid);

  foreach ($_FILES as $file => $fileArray) {
    //If 'delete originals' chosen in backend and the picture
    //shall be uploaded resized this will be done locally in the applet
    //then only the detail picture will be uploaded
    //therefore adjust path of destination category
    if ($config->jg_delete_original && $config->jg_resizetomaxwidth) {
      $no_original = true;
      $picpath = $config->jg_pathimages;
    } else {
      $no_original = false;
      $picpath = $config->jg_pathoriginalimages;
    }

    $screenshot=$fileArray["tmp_name"];
    $screenshot_name=$fileArray["name"];
    $screenshot_name = Joom_FixFilename($screenshot_name);

    $tag = strtolower(JFile::getExt($screenshot_name));

    //Create new filename
    //if generic filename setted in backend use them
    if ( $config->jg_useorigfilename ) {
      $screenshot_name = Joom_FixFilename($screenshot_name);
      $newfilename = $this->Upload_GenFilename($screenshot_name,$tag);
    } else {
      $screenshot_name = Joom_FixFilename($this->gentitle);
      $newfilename = $this->Upload_GenFilename($screenshot_name,$tag);
    }

    //Move uploaded picture in destination folder (orifinal or details)
    if (strlen($screenshot) > 0 && $screenshot != 'none') {
      JFile::upload($screenshot,JPATH_ROOT.DS.$picpath.$catpath.$newfilename);
      JPath::setPermissions(JPath::clean(JPATH_ROOT.DS.$picpath.$catpath.$newfilename));

      //Create thumbnail
      Joom_ResizeImage(JPATH_ROOT.DS.$picpath.$catpath.$newfilename,
                       JPATH_ROOT.DS.$config->jg_paththumbs.$catpath.$newfilename,
                       $config->jg_useforresizedirection, $config->jg_thumbwidth, $config->jg_thumbheight,
                       $config->jg_thumbcreation, $config->jg_thumbquality);

      echo JText::_('JGA_THUMBNAIL_CREATED')."\n";

      //evtl. create detail picture
      //not if 'delete originals' and resize setted in backend
      //In this case the applet made the resize and upload the detail picture
      if (!$no_original) {
        if ($config->jg_resizetomaxwidth && ($this->create_special_gif != 1 || ($tag != 'gif' && $tag != 'png'))) {
          Joom_ResizeImage(JPATH_ROOT.DS.$picpath.$catpath.$newfilename,
                           JPATH_ROOT.DS.$config->jg_pathimages.$catpath.$newfilename, false,
                           $config->jg_maxwidth, false, $config->jg_thumbcreation, $config->jg_thumbquality, true);
          echo JText::_('JGA_RESIZED_TO_MAXWIDTH')."\n";
        } else {
          JFile::copy($picpath.$catpath.$newfilename,
                      $config->jg_pathimages.$catpath.$newfilename,
                      JPATH_ROOT);
          JPath::setPermissions(JPath::clean(JPATH_ROOT.DS.$config->jg_pathimages.$catpath.$newfilename));
        }
      }
      //Delete original picture only if setted in upload window
      //not if setted in backend
      if($config->jg_delete_original== 2 && $this->original_delete==1) {
        if(JFile::delete(JPATH_ROOT.DS.$config->jg_pathoriginalimages.$catpath.$newfilename)) {
          echo JText::_('JGA_ORIGINAL_DELETED');
        } else {
          echo('JOOMGALLERYUPLOADERROR '.
              JText::_('JGA_PROBLEM_DELETING_ORIGINAL') .
              ': ' .
              JPath::clean(JPATH_ROOT.DS.$config->jg_pathoriginalimages) .
              ' ' .
              JText::_('JGA_CHECK_PERMISSIONS'));
          die;
        }
      }

      //new entry for ordering
      $ordering = $this->Upload_GetOrdering($config->jg_uploadorder,$catid);

      $batchtime = mktime();
      if ( $config->jg_useorigfilename ) {
        $fileextensionlength = strlen($tag);
        $filenamelength = strlen($screenshot_name);
        $imgname = substr($screenshot_name,-$filenamelength,-$fileextensionlength-1);
      } else {
        $imgname = $this->gentitle;
      }
      $query= "INSERT INTO #__joomgallery(id, catid, imgtitle, imgauthor,
          imgtext, imgdate, imgcounter, imgvotes,
          imgvotesum, published, imgfilename, imgthumbname,
          checked_out,owner,approved, ordering)
          VALUES
          (NULL, '$catid', '$imgname', '$this->photocred',
          '$this->gendesc', '$batchtime', '0', '0',
          '0', '1', '$newfilename', '$newfilename',
          '0', '".$user->get('id')."', 1, '$ordering')";

      $result = $database->setQuery($query);

      if (!$database->query()) {
        echo('JOOMGALLERYUPLOADERROR '. $database->getErrorMsg());
        die;
      }
    } else {
      echo('JOOMGALLERYUPLOADERROR '.JText::_('JGA_WRONG_FILENAME'));
      die;
    }
  }
  //Do not modify the following lines, otherwise the applet does not
  //recognize the succesful upload and shows an error message
  echo "\r\nJOOMGALLERYUPLOADSUCCESS";
  exit;
}

/**
* Generate filename
* Example: <name/gen. tile>_<evtl. filecounter>_<20071031>_<random number>.jpg
* @param $filename string original name e.g. 'malta.jpg'
* @param $tag string filetag e.g. '.jpg'
* @param $this->filecounter int evtl. for batch and FTP upload
*/
function Upload_GenFilename ($filename,$tag,$filecounter = NULL) {
  $filedate = date("Ymd");
  mt_srand();
  $randomnumber = mt_rand(1000000000, 2099999999);

  //remove filetag = $tag incl '.'
  //only if exists in filename
  if (stristr($filename,$tag)) {
    $filename = substr($filename,0,strlen($filename)-strlen($tag)-1);
  }

  //new filename
  if ( $filecounter == NULL) {
    $newfilename = $filename.'_'.$filedate.'_'.$randomnumber.'.'.$tag;
  } else {
    $newfilename = $filename.'_'.$filecounter.'_'.$filedate.'_'.$randomnumber.'.'.$tag;
  }
  return $newfilename;
}

/**
* Create DB entry for picture or send other queries to DB
* @param Query string
* @param loadObject bool false=returns an object
* @return $result string
*/
function Upload_DBQuery ($query,$loadObject=false) {
  $database = & JFactory::getDBO();
  $database->setQuery($query);
  if ($loadObject) {
    $database->loadObject($result);
  } else {
    $result=$database->loadResult();
  }
  return $result;
}

/**
* Sets new ordering according to $config->jg_uploadorder
* @param $type int  $config->jg_uploadorder ASC,DESC
* @param int category id
* @return int new ordering
*/
function Upload_GetOrdering ($type,$catid) {
  switch ($type) {
    case 1:
      $query = "SELECT MIN(ordering)-1
          FROM #__joomgallery
          WHERE catid=$catid ";

      $result = $this->Upload_DBQuery($query);
      if (!$result){
        $result=-1;
      }
      break;
    case 2:
      $query = "SELECT MAX(ordering)+1
          FROM #__joomgallery
          WHERE catid=$catid ";
      $result = $this->Upload_DBQuery($query);
      break;
    default;
      $result = 1;
      break;
  }
  if ($result == NULL) {
    $result = 1;
  }
  return $result;
}

/**
 * Calculates the serial number for picture files and title
 * in FTP and Batchupload
 * @param int total count of all pictures to upload
 * @return int new serial number
 */
function Upload_GetSerial ($totalcount=0) {
  $config = Joom_getConfig();
  static $picserial;

  //check if the initial value is already calculated
  if (isset($picserial)){
    $picserial++;
    return $picserial;
  }
  
  //calculate the initial value
  $picserial=0;
  
  //Start value setted in backend
  //no negative or 0 starting value 
  if($this->filecounter < 1) {
    $picserial = 1;
  } else {
    $picserial=$this->filecounter;
  }

  return $picserial;
}

/**
* Analyzes the error codes
* and outputs their text
* @param errorcode
* TODO aha: dev. and activate
*/
function Upload_CheckError ($uploaderror) {
  $uploadErrors = array(

  );
  if (in_array($uploaderror, $uploadErrors)) {
    echo JText::_('JGA_ERROR_CODE') . $uploadErrors[$uploaderror] . '<br />';
  } else {
    echo JText::_('JGA_ERROR_CODE') . JText::_('JGA_ERROR_UNKNOWN') . ' <br />';
  }
}

}
?>
